/**************************************+
Modulo que implementa la clase arbol binario ordenado
****************************************************/

#include "Arbol.h"
#include "Astring.h"

int contador = 0;

Arbol::Arbol(nodo* p) {
	e_arbol=p;
}

bool Arbol::Vacio() {
	return (e_arbol==NULL);
}


Token Arbol::Raiz() {
	return (e_arbol->info);
}



Arbol Arbol::HijoIzq() {
	return Arbol(e_arbol->hizq);
}



Arbol Arbol::HijoDer() {
	return Arbol(e_arbol->hder);
}


void Arbol::Insertar(Token p) {
	nodo *v;
	if((v = new nodo) == NULL) {
		cout << "ERROR: Arbol::insertar: new \n";
		exit(1);
	}

	v->info = p;
	v->hizq = NULL;
	v->hder = NULL;
	
	v = Insert(v);
}


double Arbol::Evaluar() {
	double op1, op2;

	Astring astTemporal;
	double  dblTemporal;
	char*	chrTemporal;
	
	if (Vacio()) {
		return 0;
	}
	
	op1 = HijoIzq().Evaluar();
	op2 = HijoDer().Evaluar();
	
	
	
	if (e_arbol->info.Nombre() == "NUM") {
        // si es un dgito lo mete en la pila
		astTemporal = e_arbol->info.lexema();
		chrTemporal = astTemporal.AstrToChar();
		dblTemporal = atof(chrTemporal);
		
		return dblTemporal;
		
    } else if (e_arbol->info.Nombre() == "OP_SUM") { // Si es + o -, saca los operandos
		
		
		if (e_arbol->info.lexema() == "+") {
			return (op1 + op2); // mete el resultado intermedio en la pila
		} else {
			return (op1 - op2);  // lo mete en la pila
		}
	} else if (e_arbol->info.Nombre() == "OP_MUL") {
		
		if (e_arbol->info.lexema() == "*") {
			return (op1 * op2); // mete el resultado intermedio en la pila
		} else {
			
			if (op2 != 0) {
				return (op1 / op2);  // lo mete en la pila
			} else {
				cout << endl << ("No se puede dividir entre cero");
				exit(1);
			}
		}
		
	}
	return 0;
		
}

Arbol::nodo* Arbol::Insert( nodo * v) { 
	
	nodo* recorre = e_arbol;

	Arbol aux;
	

	if (e_arbol == NULL) {
		// El rbol est vaco
		e_arbol = v;

		return e_arbol;
	}

	if (recorre->info.Nombre() == "NUM") {
		nodo* padre = new nodo;
		padre->info.prpTipo(Token::PADRE_VACIO);

		padre->hizq = recorre;
		padre->hder = v;
		
		e_arbol = padre;
		
		return e_arbol;
	}

	if (recorre->info.Nombre() == "PADRE_VACIO") {
		// Se cambia PADRE_VACIO
		if (v->info.Nombre() == "NUM") {
			recorre->hder = HijoDer().Insert(v);
						
		} else {
			if (recorre->hder->info.Nombre() == "PADRE_VACIO") {
				recorre->hder = HijoDer().Insert(v);
			} else {
				recorre->info = v->info;
			}
			
		}
		return e_arbol;
	}


	if ((recorre->info.Nombre() == "OP_SUM") || (recorre->info.Nombre() == "OP_SUM")) {
		nodo* padre = new nodo;
		padre->info.prpTipo(Token::PADRE_VACIO);

		padre->hizq = recorre;
		padre->hder = v;

		e_arbol = padre;
		
		return e_arbol;

	}

	return e_arbol;
}




ostream& operator << (ostream &salida, Arbol &B) {  // Operador de salida


	if (!(B.Vacio())) {
		cout << B.Raiz() << endl;
		
		if (!(B.HijoIzq().Vacio())) {
			for (int i = 0; i <= contador; i++) {
				cout << "  ";	
			}
			contador++;
			cout << B.HijoIzq();
			contador--;
		} 

		if (!(B.HijoDer().Vacio())) {
			for (int i = 0; i <= contador; i++) {
				cout << "  ";	
			}
			contador++;
			cout << B.HijoDer();	
			contador--;
		}
	}

	
	return salida;
}
