// Astring.cpp        (c) 2001 adolfo@di-mare.com

/* programador: Adolfo Di Mare
*/

/* invariante
   this->_s == 0 ==> la hilera est vaca
   this->_s != 0 ==> *(_s) es un vector en memoria dinmica de n+1 chars,
                     con n == strlen(_s)
   Astring::null == 0 siempre ==> sta es la hilera nula ""
*/

#include "Astring.h"


char Astring::null = 0;

Astring& Astring::operator = (const char *str) {
/*  resultado
    Cambia el valor de "*this" para que sea igual a "str".
*/
    if (_s != 0) {  // borra el valor anterior
        delete [] _s;
        _s = 0;
    }

    if (str != 0) {          // no est vaca y...
        if (str[0] != 0) {   // no es la hilera nula
            _s = new char [1 + strlen(str)];
            strcpy( _s, str );
        }
    }
    return *this;
}

Astring& Astring::operator += (const char * str) {
/*  resultado
    Le agrega al final a "*this" el valor de "str".
*/
    if (str == 0) {
        return *this;  // no hay nada que agregar
    }
    if (str[0] == 0) {
        return *this;
    }

    if (_s == 0) {  // copia directo la hilera
        size_t len_str = strlen(str);
        _s = new char [1 + len_str];
        memcpy( _s, str, len_str );
        _s[len_str] = 0;
    }
    else {
        size_t len_s   = strlen(_s);
        size_t len_str = strlen(str);

        char * tmp = new char [len_s + len_str + 1];

        memcpy(tmp,       _s,  len_s);
        memcpy(tmp+len_s, str, len_str);
        tmp[len_s + len_str] = 0;

        delete []_s;
        _s = tmp;
    }
    return *this;
}


ostream& operator << (ostream &salida, Astring &B) {  // Operador de salida

    /* Operador de salida */

   salida << B._s;
	
   return salida;
}  // operador <<

// EOF: Astring.cpp
