// Astring.h      (c) 2001 adolfo@di-mare.com

/*  resultado
    Implementa algunas de las operaciones principales para la
    clase "Astring" de hileras.
    - La implementacin es muy simple y funciona, pero no es muy eficiente
      (es adecuada para los estudiantes).
*/

/*  programador: Adolfo Di Mare
*/

#ifndef Astring_h
#define Astring_h // evita la inclusin mltiple

#if defined(__BORLANDC__)  // Compilando con Borland C++
    #include <bool.h>      // Define bool para BC++ v3.1 o inferior
#endif

#include <cstdlib>
#include <cstring>
#include <iostream.h>

class ostream; class istream; // para operator << y operator >>

class Astring {
private:
    char * _s;
    static char null;  // "" == hilera nula
public:
    Astring()                : _s(0) { }  // constructor de vector
    Astring(Astring& str)    : _s(0) { *this = str._s; }
    Astring(const char* str) : _s(0) { *this = str;    }

    Astring(char c) : _s(0) { char v[2]; v[0] = c; v[1] = 0;
        *this = v; }
    ~Astring() { if (_s != 0) { delete [] _s; } }  // destructor

    Astring& operator  = (const char *);
    Astring& operator  = (const Astring& str) { return *this = str._s; }

    Astring& operator += (const Astring& str) { return *this += str._s; }
    Astring& operator += (const char *);

    char& operator[] (size_t i) { return _s[i]; }

    friend Astring operator + (const Astring&, const Astring&);

    operator const char* () const { return (_s==0 ? (&null) : _s); }

    friend bool operator == (const Astring&, const Astring&);
    friend bool operator <  (const Astring&, const Astring&);
    friend bool operator != (const Astring&, const Astring&);
    friend bool operator <= (const Astring&, const Astring&);
    friend bool operator >= (const Astring&, const Astring&);
    friend bool operator >  (const Astring&, const Astring&);

    friend ostream& operator << (ostream &, const Astring& );
    friend istream& operator >> (istream &,       Astring& );

    friend double real   (const Astring& );   // Conversin a real
    friend long   integer(const Astring& );   // Conversin a long

	friend ostream& operator << (ostream &salida, Astring& );
	char* AstrToChar() { return _s; }


//  excluidos porque producen ambigedad con operadores aritmticos
//  operator double () { return double(_s) / double(_den); }
//  operator long   () { return        _s  /        _den ; }
}; // Astring

inline bool operator == (const Astring &x, const char * y) {
    return strcmp((const char*)x, y) == 0;
}  // operator ==

inline bool operator  < (const Astring &x, const char * y) {
    return strcmp((const char*)x, y) < 0;
}  // operator <

inline bool operator == (const Astring &x, const Astring &y) {
    return strcmp((const char*)x, (const char*)y) == 0;
}  // operator ==

inline bool operator < (const Astring &x, const Astring &y) {
    return strcmp((const char*)x, (const char*)y) < 0;
}  // operator <

inline bool operator > (const Astring &x, const Astring &y) {
    return (y < x);
}  // operator >

inline bool operator != (const Astring& x, const Astring& y) {
    return !(x == y);
}  // operator !=

inline bool operator <= (const Astring& x, const Astring& y) {
    return !(y < x);
}  // operator <=

inline bool operator >= (const Astring& x, const Astring& y) {
    return !(x < y);
}  // operator >=

#endif // Astring_h

// EOF: Astring.h
