
%{
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "Token.h"
#include "Tarea.cpp.h"

void TragarComas(char *src);

#undef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
    { \
    int c = getchar(); \
    result = (c == EOF) ? YY_NULL : (buf[0] = c, 1); \
    }

%}

DIGITO	 [0-9]
letra	 [A-Za-z]
id		 {letra}({letra}|{DIGITO})*
Com		 ("/*"({id}|{DIGITO}|"/*")*"*/")
Numero	 {DIGITO}+(","{DIGITO}+)*("."{DIGITO}*)? 
P_Abre	 [(]
P_Cierra [)]
OP_Sum	 ("+"|"-")
OP_Mul	 ("*"|"/")

%%


{Numero}    {
			TragarComas(yytext);
			printf( "token == NUM\t\tlexema == \"%g\"\n", atof( yytext ));
			return Token::NUM;
		    }

{id}		{
	        printf( "token == ID\t\tlexema == \"%s\"\n", yytext );
			return Token::ID;
			}

{P_Abre}	{
	        printf( "token == P_ABRE\t\tlexema == \"%s\"\n", yytext );
			return Token::P_ABRE;
			}

{P_Cierra}	{
	        printf( "token == P_CIERRA\tlexema == \"%s\"\n", yytext );
			return Token::P_CIERRA;
			}


{OP_Sum}	{
			printf( "token == OP_SUM\t\tlexema == \"%s\"\n", yytext );
			return Token::OP_SUM;
			}


{OP_Mul}	{
			printf( "token == OP_MUL\t\tlexema == \"%s\"\n", yytext );
			return Token::OP_MUL;
			}


[ \t]+     {      
			/* se come los espacios en blanco */
			}

[\n]		{
			return Token::FIN;
			}

.			{	
			printf( "Caracter no reconocido: %s\n", yytext );
			return Token::ERROR;
			}
%%


Token Nuevo_yylex() {
	Token nuevo;
	int a;
	a = Tarealex();

	nuevo.prpLexema(yytext);
	nuevo.prpTipo((Token::Tipo) a);

	return nuevo;

}